#ifndef _AUTOMATE_H
#define _AUTOMATE_H

#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "liste.h"

#ifndef bool
typedef enum { FAUX = 0, VRAI = 1 } bool;
#endif

typedef struct {
    int nbetats;
    bool * terminaux;
    liste * fleches;
} Automate;

// Lit un automate depuis un fichier f
Automate * automate_lecture(FILE * f);

// Enregistre un automate dans un ficheir
int automate_enregistre(Automate * a, char * fichier);

// Affichage d'un automate
inline void automate_affiche(Automate * a);

// Libre la mmoire occupe par l'automate a
void automate_detruire(Automate * a);

// Trie les diffrentes listes de l'automate
void automate_sort(Automate *a);

/*
 * Copie in dans out
 */
int automate_copie(Automate ** out, Automate * in);

#endif /* _AUTOMATE_H */ 
