#include "equivalence.h"

/* Fonction recurrsive qui verifie que les etats de deux automates sont equivalents
 * */
int equivalence(Automate *a, Automate *b, int posA, int posB, int *classe, char *mot, int opt)
{
    int c1=0,c2=0,i=0;
    liste l1,l2;
    static int j=0;
    
    if(a->terminaux[posA] != b->terminaux[posB])
    {
	if(opt == 1)
	{
	    mot[j]='\0';
	    if(j != 0)
		printf("Un mot qui les differencie est %s\n",mot);
	    else
		printf("Un mot mot qui les differencie est le mot vide\n");
	}
	j=0;
	// non equivalence
	return 1;
    }
    else
    {
	c1=classe[posA];
	c2=classe[a->nbetats+posB];
	if(c1 != c2)
	{
	    // union
	    for(i=0;i<(a->nbetats+b->nbetats);i++)
		if(classe[i] == c2)
		    classe[i]= c1;
	    l1=a->fleches[posA];
	    l2=b->fleches[posB];  
	    while((l1 != NULL)&&(l2 != NULL))
	    {
		posA=l1->etat;
		posB=l2->etat; 
		mot[j]=l1->lettre;
		j++;
		if(l1->lettre != l2->lettre)
		{
		    mot[j]='\0';
		    if(opt == 1)
		    {
    			printf("Un mot qui les differencie est %c\n",l2->lettre);
		    }
		    j=0;
		    return 1;
		}
		if(equivalence(a,b,posA,posB,classe,mot,opt) == 1)
		    return 1;
		l1=l1->suiv;
		l2=l2->suiv;
		j--;
	    }
	
	}    
    }
    // equivalence
    return 0;
}

/* Test l'equivalence de deux automates
 * 0 equivalent
 * 1 non
 * */
int equivalence_automate(char* fichier1 , char* fichier2, int opt)
{
    Automate *a=NULL, *b=NULL;
    FILE *fichier = NULL;
    int *classe = NULL;
    int result = 1;
    int i = 0;
    char mot[128];
    
    if((fichier=fopen(fichier1,"r")) == NULL)
    {
	    fprintf(stderr,"impossible d'ouvrir le fichier %s\n",fichier1);
	    return 1;
    }
    if((a = automate_lecture(fichier)) == NULL)
    {	
	fprintf(stderr,"impossible de lire %s",fichier1);
	fclose(fichier);
	return 2; 
    }	
    fclose(fichier);
    
    if((fichier=fopen(fichier2,"r")) == NULL)
    {
	    fprintf(stderr,"impossible d'ouvrir le fichier %s\n",fichier2);
	    return 1;
    }
    if((b = automate_lecture(fichier)) == NULL)
    {
	fprintf(stderr,"impossible de lire %s",fichier2);
	fclose(fichier);
	return 3;
    }
    fclose(fichier);

    classe=(int*)malloc(sizeof(int)*(a->nbetats+b->nbetats));
    for(i=0; i<(a->nbetats+b->nbetats); i++)
	    classe[i]=i;
    
    result = equivalence(a,b,0,0,classe,mot,opt);
    
    free(classe);
    automate_detruire(a);
    automate_detruire(b);
    return result;
}

