#ifndef _LANGUE_H
#define _LANGUE_H

#include "automate.h"

typedef struct {
    char ** mots;
    int nb; // Nombre de mots
} Langue;

/*
 * Libre la mmoire associe  la langue
 */
void langue_libere(Langue * l);

/*
 * Ajoute un mot au language
 */
int langue_ajoute(Langue * l, char * mot);

/*
 * Calcule TOUS les mots engendrs par l'automate
 */
Langue * langue_automate(Automate * a);

/* 
 * Affiche la langue l
 */
inline void langue_affiche(Langue * l);

/*
 * Enregistre la langue l dans un fichier
 */
int langue_enregistre(Langue * l, char * fichier);

/*
 * Retourne une langue contenant les plus petits mots de l
 * NOTE : La langue doit tre au pralable "unbordelize"
 */
Langue * langue_mini(Langue * l);

// Calcule la liste d mots qui differre entre les deux listes
Langue* langue_diff(Langue* l1, Langue *l2);

#endif /* _LANGUE_H */
