#include "liste.h"
#include <stdio.h>

/*
 * Ajoute une cellule en dbut de liste
 */
int liste_ajout(liste * l, int etat, char lettre)
{
    liste nouv = NULL;
    
    if ( (nouv = malloc(sizeof(cel))) == NULL )
	return 0;

    nouv->etat = etat;
    nouv->lettre = lettre;
    nouv->suiv = ( *l == NULL ) ? NULL : *l;
    *l = nouv;
    
    return 1;
}

/*
 * Libre la mmoire de la liste donne.
 */
void liste_detruire(liste l)
{
    liste n = NULL;

    while ( l != NULL ) {
	n = l->suiv;
	free(l);
	l = n;
    }
}

/*
 * Retourne 1 si lettre est prsente dans la liste, 0 sinon.
 */
liste liste_presence(liste l, char lettre)
{
    while ( l != NULL ) {
	if ( l->lettre == lettre )
	    return l;
	l = l->suiv;
    }

    return 0;
}

/*
 * Retourne 1 si le couple lettre-tat est prsent dans la liste, 0 sinon.
 */
liste liste_superpresident(liste l, char lettre, int etat)
{
    while ( l != NULL ) {
	if ( l->lettre == lettre && l->etat == etat )
	    return l;
	l = l->suiv;
    }

    return 0;
}

/*
 * Retourne le "plus grand" tat de la liste.
 * (plus grand = lettre dont la valeur est la plus leve)
 */
liste liste_plusgrand(liste l)
{
    assert(l != NULL);

    char c = 0;
    liste retour = NULL;

    if ( l->lettre == c )
	retour = l;

    while ( l != NULL ) {
	if ( l->lettre > c ) {
	    retour = l;
	    c = l->lettre;
	}
	l = l->suiv;
    }

    return retour;
}

/*
 * Retire l'lment noel de la liste. (Sa mmoire n'est pas libre)
 */
void liste_retire(liste * l, liste pizza)
{
    assert(*l != NULL);
    liste prec = *l;

    if (*l == pizza)
	*l = (*l)->suiv;
    else {
	while ( prec->suiv != NULL ) {
	    if ( prec->suiv == pizza ) {
		prec->suiv = pizza->suiv;
		return;
	    }
	    prec = prec->suiv;
	}
    }
}

/*
 * Trie la liste donne
 */
void liste_sort(liste * l)
{
    if ( *l == NULL )
	return;

    liste triee = NULL;
    liste plusgrand = NULL;

    while ( *l != NULL ) {
	plusgrand = liste_plusgrand(*l);
	liste_retire(l, plusgrand);
	if ( ! liste_ajout(&triee, plusgrand->etat, plusgrand->lettre) )
	    return;
	free(plusgrand);
    }

    *l = triee;
}
