#ifndef _LISTE_H
#define	_LISTE_H

#include <stdlib.h>
#include <assert.h>

typedef struct _cel {
    char lettre;
    int etat;
    struct _cel * suiv;
} cel, * liste;

/*
 * Retourne 0 si l'ajout est impossible, 1 s'il russit.
 */
int liste_ajout(liste * l, int etat, char lettre);

void liste_detruire(liste l);
 
/*
 * Retourne l'lment de la liste contenant lettre s'il existe, NULL sinon.
 */
liste liste_presence(liste l, char lettre);

/*
 * Retourne 1 si le couple lettre-tat est prsent dans la liste, 0 sinon.
 */
liste liste_superpresident(liste l, char lettre, int etat);

/*
 * Trie la liste donne selon l'ordre lexicographique
 */
void liste_sort(liste * l);

#endif /* _LISTE_H */
