#include "main.h"

static void help(char * bin)
{
    printf("Usage : %s [-option...]\n", bin);

    puts("Options :");

    // u
    puts(" \e[0;31mu X [fichier] :\e[0m");
    puts("    Affiche l'automate des sous-mots du mot X.");
    puts("    Si un fichier est prcis, l'automate y sera enregistr.");

    // e
    puts(" \e[0;31me X Y :\e[0m");
    puts("    Teste l'quivalence des automates dcrits dans les fichiers "
	    "X et Y.");

    // E
    puts(" \e[0;31mE X Y :\e[0m");
    puts("    Teste l'quivalence des automates dcrits dans les fichiers "
	    "X et Y et");
    puts("    affiche un mot qui les spare s'ils ne sont pas quivalents.");

    // m
    puts(" \e[0;31mm X Y [fichier] :\e[0m");
    puts("    Affiche la liste des plus petits sous-mots qui spare les mots "
	    "X et Y.");
    puts("    Si un fichier est prcis, la liste y sera enregistre.");

    // a
    puts(" \e[0;31ma X Y [fichier] :\e[0m");
    puts("    Affiche l'automate des plus petits sous-mots qui spare les "
	    "mots X et Y.");
    puts("    Si un fichier est prcis, l'automate y sera enregistr.");

    // h
    puts(" \e[0;31mh :\e[0m");
    puts("    Affiche cette aide");
}

static Action option(int argc, char ** argv)
{
    if ( argc > 5 )
	goto help;

    if ( argc > 1 ) {
	if ( argv[1][0] != '-' || argv[1][2] != 0 )
	    goto help;
	switch(argv[1][1]) {
	    case 'u': 
		if ( argc != 3 && argc != 4 )
		    goto help;
		return ATMT_SOUSMOT;
	    case 'e': 
		if ( argc != 4 )
		    goto help;
		return EQUIV;
	    case 'E': 
		if ( argc != 4 )
		    goto help;
		return EQUIV_SOUSMOT;
	    case 'm': 
		if ( argc != 4 && argc != 5 )
		    goto help;
		return LISTE;
	    case 'a': 
		if ( argc != 4 && argc != 5 )
		    goto help;
		return ATMT_PSM;
	    default:
		goto help;
	}
    }

    return MENU_;

help:
    help(argv[0]);
    
    exit(1);
}

int travaille(Action action, int argc, char ** argv)
{
    Automate * pizza = NULL;
    Automate *a,*b;
    Langue * l1, * l2, *l;
    int ret = 0;

    switch(action)
    {
	case MENU_:
	    menu();
	    return 0;
	case ATMT_SOUSMOT: // -u
	    pizza = sousmot_automate(argv[2]);
	    automate_sort(pizza);
	    if ( argc == 3 )
		automate_affiche(pizza);
	    else
		automate_enregistre(pizza,argv[3]);
	    automate_detruire(pizza);
	    break;
	case EQUIV: // -e
	    ret = equivalence_automate(argv[2], argv[3], 0);
	    break;
	case EQUIV_SOUSMOT: // -E
	    ret = equivalence_automate(argv[2], argv[3], 1);
	    break;
	case LISTE: // -m
	    a=sousmot_automate(argv[2]);
	    b=sousmot_automate(argv[3]);
	  
	    l1=langue_automate(a);
	    l2=langue_automate(b);

	    l=langue_diff(l1,l2);

	    if ( argc == 4 )
	    langue_affiche(l);
	    else
		    langue_enregistre(l,argv[4]);
	    langue_libere(l1);
	    langue_libere(l);
	    langue_libere(l2);
	    automate_detruire(a);
	    automate_detruire(b);
	    break;
	case ATMT_PSM: // -a
	    puts("Fonction non-implmente");
    }

    return ret;
}

int main(int argc, char ** argv)
{
    Action action = MENU_;

    action = option(argc, argv);

    return travaille(action, argc, argv);
}
